﻿using System;
using System.Collections.Generic;
using System.Linq;


namespace SampleData
{

    public class DataUtil
    {


        private static List<Category> categories;
        private static List<Wine> wines;
        private static List<Category> categoriesandWines;


        private static List<Category> CreateCategories()
        {
            return new List<Category>
        {

            new Category
            {

                CategoryID = 0001,
                CategoryName = "Cabernet",
                Description = "jkdasjkdjkfjkjk"


            },


            new Category
            {
                CategoryID = 0002,
                CategoryName = "Merlot",
                Description = "jkdasjkdjkfjkjk"

            },

            new Category
            {
                CategoryID = 0003,
                CategoryName = "Pinot Noir",
                Description = "jkdasjkdjkfjkjk"

            },

            
            new Category
            {
                CategoryID = 0004,
                CategoryName = "Red Zinfandel",
                Description = "jkdasjkdjkfjkjk"

            },


            new Category
            {
                CategoryID = 0005,
                CategoryName = "Syrah",
                Description = "jkdasjkdjkfjkjk"

            },


            new Category
            {
                CategoryID = 0006,
                CategoryName = "Bordeaux Blend",
                Description = "jkdasjkdjkfjkjk"

            },


            new Category
            {
                CategoryID = 0007,
                CategoryName = "Beaujolais",
                Description = "jkdasjkdjkfjkjk"

            },

             new Category
            {
                CategoryID = 0008,
                CategoryName = "Rose",
                Description = "jkdasjkdjkfjkjk"

            },


             new Category
            {
                CategoryID = 0009,
                CategoryName = "Zinfandel",
                Description = "jkdasjkdjkfjkjk"

            },

            new Category
            {
                CategoryID = 0010,
                CategoryName = "Sangiovese",
                Description = "jkdasjkdjkfjkjk"

            },

             new Category
            {
                CategoryID = 0011,
                CategoryName = "Sangria",
                Description = "jkdasjkdjkfjkjk"

            }

            
        };
        }


        private static List<Wine> CreateWines()
        {
            return new List<Wine>
            {

                new Wine
                {
                    WineID = 1,
                    ProductName = "Kendal Jackson",
                    Region = "Calistoga",
                    Country = "United States",
                    VintageYear = null,
                    CategoryID = 0001,
                    AverageUnitPricePerBottle = 17.9900m,
                    RecommendToFriend = true,
                    TroyRating = 2,


                },


                new Wine
                {
                    WineID = 2,
                    ProductName = "Kunde",
                    Region = "Sonoma",
                    Country = "United States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0001,
                    AverageUnitPricePerBottle = 25.9900m,
                    RecommendToFriend = true,
                    TroyRating = 5,


                },


                new Wine
                {
                    WineID = 3,
                    ProductName = "Vincent Arroyo",
                    Region = "Calistoga",
                    Country = "Unites States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0003,
                    AverageUnitPricePerBottle = 25.9900m,
                    RecommendToFriend = false,
                    TroyRating = 1,


                },


                new Wine
                {
                    WineID = 4,
                    ProductName = "Joseph Phelps",
                    Region = "Napa",
                    Country = "United States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0004,
                    AverageUnitPricePerBottle = 12.9900m,
                    RecommendToFriend = true,
                    TroyRating = 4,


                },


                 new Wine
                {
                    WineID = 5,
                    ProductName = "Silver Oak",
                    Region = "Napa",
                    Country = "United States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0005,
                    AverageUnitPricePerBottle = 16.9900m,
                    RecommendToFriend = false,
                    TroyRating = 5,


                },


                 new Wine
                {
                    WineID = 6,
                    ProductName = "Mark West",
                    Region = "Sonoma",
                    Country = "United States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0003,
                    AverageUnitPricePerBottle = 14.9900m,
                    RecommendToFriend = true,
                    TroyRating = 2,


                },


                new Wine
                {
                    WineID = 7,
                    ProductName = "Chateau Souverain",
                    Region = "Sonoma",
                    Country = "Unites States",
                    VintageYear = null,
                    CategoryID = 0007,
                    AverageUnitPricePerBottle = 57.9900m,
                    RecommendToFriend = true,
                    TroyRating = 4,


                },

                new Wine
                {
                    WineID = 8,
                    ProductName = "Cloudline",
                    Region = "Oregon",
                    Country = "United States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0008,
                    AverageUnitPricePerBottle = 100.9900m,
                    RecommendToFriend = true,
                    TroyRating = 3,


                },

                new Wine
                {
                    WineID = 9,
                    ProductName = "La Suave",
                    Region = "Calistoga",
                    Country = "Unites States",
                    VintageYear = System.DateTime.Now,
                    CategoryID = 0009,
                    AverageUnitPricePerBottle = 5.9900m,
                    RecommendToFriend = false,
                    TroyRating = 2,


                },

                new Wine
                {
                    WineID = 10,
                    ProductName = "Chateau Montelena",
                    Region = "Calistoga",
                    Country = "United States",
                    VintageYear = null,
                    CategoryID = 0010,
                    AverageUnitPricePerBottle = 11.9900m,
                    RecommendToFriend = false,
                    TroyRating = 2,


                }



            };
        }


        private static List<Category> CreateCategoriesandWine()
        {
            List<Category> retVal = CreateCategories();
            List<Wine> tempWines = CreateWines();
            Category parentCategory = null;

            foreach (Wine w in tempWines)
            {
                if (parentCategory == null | parentCategory.CategoryID != w.CategoryID)
                {
                    parentCategory = retVal.First<Category>(category => category.CategoryID == w.CategoryID);

                }

                parentCategory.Wine.Add(w);
            }

            return retVal;

        }


        public static List<Category> Categories
        {
            get
            {

                if (categories == null)
                    categories = CreateCategories();

                return categories;

            }


        }

        public static List<Wine> Wines
        {
            get
            {

                if (wines == null)
                    wines = CreateWines();

                return wines;

            }


        }

        public static List<Category> CategoriesandWines
        {
            get
            {

                if (categoriesandWines == null)
                    categoriesandWines = CreateCategoriesandWine();

                return CategoriesandWines;

            }


        }







        public class Category
        {
            private int categoryID;
            private string categoryName;
            private string description;
            private List<Wine> wines;

            public int CategoryID
            {
                get
                {
                    return this.categoryID;
                }

                set
                {
                    if (this.categoryID != value)
                    {
                        this.categoryID = value;
                    }
                }
            }


            public string CategoryName
            {
                get
                {
                    return this.categoryName;
                }

                set
                {
                    if (this.categoryName != value)
                    {
                        this.categoryName = value;
                    }
                }
            }


            public string Description
            {
                get
                {
                    return this.description;
                }

                set
                {
                    if (this.description != value)
                    {
                        this.description = value;
                    }
                }
            }


            public List<Wine> Wine
            {
                get
                {
                    if (wines == null)
                    {
                        wines = new List<Wine>();
                    }

                    return this.wines;
                }
            }

        }


        public class Wine
        {

            private int wineID;
            private string productName;
            private string region;
            private string country;
            private DateTime ? vintageYear;
            private int categoryID;
            private decimal avgUnitPricePerBottle;
            private bool recommendToFriend;
            private int troyRating;







            public int WineID
            { get; set; }


            public string ProductName
            { get; set; }
               

            public string Region
           { get; set; }
            


            public string Country
            { get; set; }
            


            public Nullable <DateTime> VintageYear
            {
                get
                {
                    return this.vintageYear;
                }

                set
                {                   
                    this.vintageYear = value;                    
                }
            }

            public int CategoryID
            {
                get
                {
                    return this.categoryID;
                }

                set
                {
                    if (this.categoryID != value)
                    {
                        this.categoryID = value;
                    }
                }
            }


            public decimal AverageUnitPricePerBottle
            {
                get
                {
                    return this.avgUnitPricePerBottle;
                }

                set
                {
                    if (this.avgUnitPricePerBottle != value)
                    {
                        this.avgUnitPricePerBottle = value;
                    }
                }
            }



            public bool RecommendToFriend
            {
                get
                {
                    return this.recommendToFriend;
                }

                set
                {
                   this.recommendToFriend = value;

                   
                }
            }


            public int TroyRating
            {
                get
                {
                    return this.troyRating;
                }

                set
                {
                    if (this.troyRating != value)
                    {
                        this.troyRating = value;
                    }
                }
            }


            




        }
    }
}